(* -*- fsharp -*- *)

module Generate_InstrIO

let main() =
    match System.Environment.GetCommandLineArgs() with
        | [| _; f_out |] ->
            let w = new System.IO.StreamWriter(f_out)
            fprintfn w "(* -*- fsharp -*- *)\n"

            fprintfn w "module Test_IO_JSON"

            EmitJSONio.emitModulePrelude w
(*            fprintfn w "open X64instr"
            fprintfn w "open Test"
            fprintfn w "open JSON"
            fprintfn w "open System.Collections.Generic"
            *)
            fprintfn w "\n\n"

            EmitJSONio.emitUnparser w "unparse_int_to_JSONvalue"  typeof<int>
            EmitJSONio.emitParser   w "parse_JSONvalue_to_int"    typeof<int>

            EmitJSONio.emitUnparser w "unparse_tree_to_JSON" typeof<Test.tree>
            EmitJSONio.emitParser   w "parse_JSON_to_tree"   typeof<Test.tree> 


            EmitJSONio.emitUnparser w "unparse_JSONvalue_to_JSONvalue" typeof<JSON.Value>
            EmitJSONio.emitParser   w "parse_JSONvalue_to_JSONvalue"   typeof<JSON.Value>

            EmitJSONio.emitUnparser w "unparse_bintree_to_JSON" typeof<Test.bintree>
            EmitJSONio.emitParser   w "parse_JSON_to_bintree"   typeof<Test.bintree>

            EmitJSONio.emitUnparser w "unparse_Instr_to_JSONvalue" typeof<X64instr.Instr>
            EmitJSONio.emitParser   w "parse_JSONvalue_to_Instr"   typeof<X64instr.Instr>

            fprintfn w "(* END *)"
            w.Close()

            
        | _ -> eprintfn "usage: gen_fs <output_filename>"
        
main()
