// Implementation file for parser generated by fsyacc
module AttParser
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 1 "AttParser.fsy"

open X64instr
open Ast

# 11 "AttParser.fs"
// This type is the type of tokens accepted by the parser
type token = 
  | L_OR
  | L_AND
  | L_LEQ
  | L_GEQ
  | L_LT
  | L_GT
  | L_NEQ
  | L_EQ
  | PIPE
  | AMPERSAND
  | HAT
  | BANG
  | TILDE
  | PLUS
  | MINUS
  | STAR
  | SLASH
  | PERCENT
  | A_SHL
  | A_SHR
  | A_NOT
  | YMMreg of (X64instr.Y)
  | XMMreg of (X64instr.X)
  | R64reg of (X64instr.R64)
  | R32reg of (X64instr.R32)
  | R16reg of (X64instr.R16)
  | R8reg of (X64instr.R8)
  | STR of (System.String)
  | ID of (System.String)
  | IDeol of (System.String)
  | LABEL of (System.String)
  | FLOAT of (System.Double)
  | INT of (System.Numerics.BigInteger)
  | LIT of (System.Numerics.BigInteger)
  | EOF
  | EOL
  | AT
  | DOLLAR
  | LPAREN
  | RPAREN
  | COMMA
  | R32ip
  | R64ip
  | R32iz
  | R64iz
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_L_OR
    | TOKEN_L_AND
    | TOKEN_L_LEQ
    | TOKEN_L_GEQ
    | TOKEN_L_LT
    | TOKEN_L_GT
    | TOKEN_L_NEQ
    | TOKEN_L_EQ
    | TOKEN_PIPE
    | TOKEN_AMPERSAND
    | TOKEN_HAT
    | TOKEN_BANG
    | TOKEN_TILDE
    | TOKEN_PLUS
    | TOKEN_MINUS
    | TOKEN_STAR
    | TOKEN_SLASH
    | TOKEN_PERCENT
    | TOKEN_A_SHL
    | TOKEN_A_SHR
    | TOKEN_A_NOT
    | TOKEN_YMMreg
    | TOKEN_XMMreg
    | TOKEN_R64reg
    | TOKEN_R32reg
    | TOKEN_R16reg
    | TOKEN_R8reg
    | TOKEN_STR
    | TOKEN_ID
    | TOKEN_IDeol
    | TOKEN_LABEL
    | TOKEN_FLOAT
    | TOKEN_INT
    | TOKEN_LIT
    | TOKEN_EOF
    | TOKEN_EOL
    | TOKEN_AT
    | TOKEN_DOLLAR
    | TOKEN_LPAREN
    | TOKEN_RPAREN
    | TOKEN_COMMA
    | TOKEN_R32ip
    | TOKEN_R64ip
    | TOKEN_R32iz
    | TOKEN_R64iz
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startASTitem
    | NONTERM__startASTlines
    | NONTERM__startASTline
    | NONTERM_ASTlines
    | NONTERM_ASTitem
    | NONTERM_ASTline
    | NONTERM_Lines1
    | NONTERM_Line
    | NONTERM_Items1
    | NONTERM_EOLS
    | NONTERM_IDx
    | NONTERM_Item
    | NONTERM_EA32
    | NONTERM_EA64
    | NONTERM_Iexpr
    | NONTERM_IexprI

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | L_OR  -> 0 
  | L_AND  -> 1 
  | L_LEQ  -> 2 
  | L_GEQ  -> 3 
  | L_LT  -> 4 
  | L_GT  -> 5 
  | L_NEQ  -> 6 
  | L_EQ  -> 7 
  | PIPE  -> 8 
  | AMPERSAND  -> 9 
  | HAT  -> 10 
  | BANG  -> 11 
  | TILDE  -> 12 
  | PLUS  -> 13 
  | MINUS  -> 14 
  | STAR  -> 15 
  | SLASH  -> 16 
  | PERCENT  -> 17 
  | A_SHL  -> 18 
  | A_SHR  -> 19 
  | A_NOT  -> 20 
  | YMMreg _ -> 21 
  | XMMreg _ -> 22 
  | R64reg _ -> 23 
  | R32reg _ -> 24 
  | R16reg _ -> 25 
  | R8reg _ -> 26 
  | STR _ -> 27 
  | ID _ -> 28 
  | IDeol _ -> 29 
  | LABEL _ -> 30 
  | FLOAT _ -> 31 
  | INT _ -> 32 
  | LIT _ -> 33 
  | EOF  -> 34 
  | EOL  -> 35 
  | AT  -> 36 
  | DOLLAR  -> 37 
  | LPAREN  -> 38 
  | RPAREN  -> 39 
  | COMMA  -> 40 
  | R32ip  -> 41 
  | R64ip  -> 42 
  | R32iz  -> 43 
  | R64iz  -> 44 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_L_OR 
  | 1 -> TOKEN_L_AND 
  | 2 -> TOKEN_L_LEQ 
  | 3 -> TOKEN_L_GEQ 
  | 4 -> TOKEN_L_LT 
  | 5 -> TOKEN_L_GT 
  | 6 -> TOKEN_L_NEQ 
  | 7 -> TOKEN_L_EQ 
  | 8 -> TOKEN_PIPE 
  | 9 -> TOKEN_AMPERSAND 
  | 10 -> TOKEN_HAT 
  | 11 -> TOKEN_BANG 
  | 12 -> TOKEN_TILDE 
  | 13 -> TOKEN_PLUS 
  | 14 -> TOKEN_MINUS 
  | 15 -> TOKEN_STAR 
  | 16 -> TOKEN_SLASH 
  | 17 -> TOKEN_PERCENT 
  | 18 -> TOKEN_A_SHL 
  | 19 -> TOKEN_A_SHR 
  | 20 -> TOKEN_A_NOT 
  | 21 -> TOKEN_YMMreg 
  | 22 -> TOKEN_XMMreg 
  | 23 -> TOKEN_R64reg 
  | 24 -> TOKEN_R32reg 
  | 25 -> TOKEN_R16reg 
  | 26 -> TOKEN_R8reg 
  | 27 -> TOKEN_STR 
  | 28 -> TOKEN_ID 
  | 29 -> TOKEN_IDeol 
  | 30 -> TOKEN_LABEL 
  | 31 -> TOKEN_FLOAT 
  | 32 -> TOKEN_INT 
  | 33 -> TOKEN_LIT 
  | 34 -> TOKEN_EOF 
  | 35 -> TOKEN_EOL 
  | 36 -> TOKEN_AT 
  | 37 -> TOKEN_DOLLAR 
  | 38 -> TOKEN_LPAREN 
  | 39 -> TOKEN_RPAREN 
  | 40 -> TOKEN_COMMA 
  | 41 -> TOKEN_R32ip 
  | 42 -> TOKEN_R64ip 
  | 43 -> TOKEN_R32iz 
  | 44 -> TOKEN_R64iz 
  | 47 -> TOKEN_end_of_input
  | 45 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startASTitem 
    | 1 -> NONTERM__startASTlines 
    | 2 -> NONTERM__startASTline 
    | 3 -> NONTERM_ASTlines 
    | 4 -> NONTERM_ASTlines 
    | 5 -> NONTERM_ASTlines 
    | 6 -> NONTERM_ASTitem 
    | 7 -> NONTERM_ASTline 
    | 8 -> NONTERM_Lines1 
    | 9 -> NONTERM_Lines1 
    | 10 -> NONTERM_Line 
    | 11 -> NONTERM_Line 
    | 12 -> NONTERM_Line 
    | 13 -> NONTERM_Line 
    | 14 -> NONTERM_Line 
    | 15 -> NONTERM_Line 
    | 16 -> NONTERM_Line 
    | 17 -> NONTERM_Items1 
    | 18 -> NONTERM_Items1 
    | 19 -> NONTERM_Items1 
    | 20 -> NONTERM_EOLS 
    | 21 -> NONTERM_EOLS 
    | 22 -> NONTERM_IDx 
    | 23 -> NONTERM_IDx 
    | 24 -> NONTERM_Item 
    | 25 -> NONTERM_Item 
    | 26 -> NONTERM_Item 
    | 27 -> NONTERM_Item 
    | 28 -> NONTERM_Item 
    | 29 -> NONTERM_Item 
    | 30 -> NONTERM_Item 
    | 31 -> NONTERM_Item 
    | 32 -> NONTERM_Item 
    | 33 -> NONTERM_Item 
    | 34 -> NONTERM_Item 
    | 35 -> NONTERM_Item 
    | 36 -> NONTERM_Item 
    | 37 -> NONTERM_Item 
    | 38 -> NONTERM_Item 
    | 39 -> NONTERM_Item 
    | 40 -> NONTERM_Item 
    | 41 -> NONTERM_EA32 
    | 42 -> NONTERM_EA32 
    | 43 -> NONTERM_EA32 
    | 44 -> NONTERM_EA32 
    | 45 -> NONTERM_EA32 
    | 46 -> NONTERM_EA32 
    | 47 -> NONTERM_EA32 
    | 48 -> NONTERM_EA32 
    | 49 -> NONTERM_EA32 
    | 50 -> NONTERM_EA32 
    | 51 -> NONTERM_EA32 
    | 52 -> NONTERM_EA32 
    | 53 -> NONTERM_EA32 
    | 54 -> NONTERM_EA32 
    | 55 -> NONTERM_EA32 
    | 56 -> NONTERM_EA64 
    | 57 -> NONTERM_EA64 
    | 58 -> NONTERM_EA64 
    | 59 -> NONTERM_EA64 
    | 60 -> NONTERM_EA64 
    | 61 -> NONTERM_EA64 
    | 62 -> NONTERM_EA64 
    | 63 -> NONTERM_EA64 
    | 64 -> NONTERM_EA64 
    | 65 -> NONTERM_EA64 
    | 66 -> NONTERM_EA64 
    | 67 -> NONTERM_EA64 
    | 68 -> NONTERM_EA64 
    | 69 -> NONTERM_EA64 
    | 70 -> NONTERM_EA64 
    | 71 -> NONTERM_Iexpr 
    | 72 -> NONTERM_Iexpr 
    | 73 -> NONTERM_Iexpr 
    | 74 -> NONTERM_Iexpr 
    | 75 -> NONTERM_Iexpr 
    | 76 -> NONTERM_Iexpr 
    | 77 -> NONTERM_Iexpr 
    | 78 -> NONTERM_Iexpr 
    | 79 -> NONTERM_Iexpr 
    | 80 -> NONTERM_Iexpr 
    | 81 -> NONTERM_Iexpr 
    | 82 -> NONTERM_Iexpr 
    | 83 -> NONTERM_Iexpr 
    | 84 -> NONTERM_Iexpr 
    | 85 -> NONTERM_Iexpr 
    | 86 -> NONTERM_Iexpr 
    | 87 -> NONTERM_Iexpr 
    | 88 -> NONTERM_Iexpr 
    | 89 -> NONTERM_Iexpr 
    | 90 -> NONTERM_Iexpr 
    | 91 -> NONTERM_Iexpr 
    | 92 -> NONTERM_Iexpr 
    | 93 -> NONTERM_Iexpr 
    | 94 -> NONTERM_Iexpr 
    | 95 -> NONTERM_Iexpr 
    | 96 -> NONTERM_IexprI 
    | 97 -> NONTERM_IexprI 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 47 
let _fsyacc_tagOfErrorTerminal = 45

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | L_OR  -> "L_OR" 
  | L_AND  -> "L_AND" 
  | L_LEQ  -> "L_LEQ" 
  | L_GEQ  -> "L_GEQ" 
  | L_LT  -> "L_LT" 
  | L_GT  -> "L_GT" 
  | L_NEQ  -> "L_NEQ" 
  | L_EQ  -> "L_EQ" 
  | PIPE  -> "PIPE" 
  | AMPERSAND  -> "AMPERSAND" 
  | HAT  -> "HAT" 
  | BANG  -> "BANG" 
  | TILDE  -> "TILDE" 
  | PLUS  -> "PLUS" 
  | MINUS  -> "MINUS" 
  | STAR  -> "STAR" 
  | SLASH  -> "SLASH" 
  | PERCENT  -> "PERCENT" 
  | A_SHL  -> "A_SHL" 
  | A_SHR  -> "A_SHR" 
  | A_NOT  -> "A_NOT" 
  | YMMreg _ -> "YMMreg" 
  | XMMreg _ -> "XMMreg" 
  | R64reg _ -> "R64reg" 
  | R32reg _ -> "R32reg" 
  | R16reg _ -> "R16reg" 
  | R8reg _ -> "R8reg" 
  | STR _ -> "STR" 
  | ID _ -> "ID" 
  | IDeol _ -> "IDeol" 
  | LABEL _ -> "LABEL" 
  | FLOAT _ -> "FLOAT" 
  | INT _ -> "INT" 
  | LIT _ -> "LIT" 
  | EOF  -> "EOF" 
  | EOL  -> "EOL" 
  | AT  -> "AT" 
  | DOLLAR  -> "DOLLAR" 
  | LPAREN  -> "LPAREN" 
  | RPAREN  -> "RPAREN" 
  | COMMA  -> "COMMA" 
  | R32ip  -> "R32ip" 
  | R64ip  -> "R64ip" 
  | R32iz  -> "R32iz" 
  | R64iz  -> "R64iz" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | L_OR  -> (null : System.Object) 
  | L_AND  -> (null : System.Object) 
  | L_LEQ  -> (null : System.Object) 
  | L_GEQ  -> (null : System.Object) 
  | L_LT  -> (null : System.Object) 
  | L_GT  -> (null : System.Object) 
  | L_NEQ  -> (null : System.Object) 
  | L_EQ  -> (null : System.Object) 
  | PIPE  -> (null : System.Object) 
  | AMPERSAND  -> (null : System.Object) 
  | HAT  -> (null : System.Object) 
  | BANG  -> (null : System.Object) 
  | TILDE  -> (null : System.Object) 
  | PLUS  -> (null : System.Object) 
  | MINUS  -> (null : System.Object) 
  | STAR  -> (null : System.Object) 
  | SLASH  -> (null : System.Object) 
  | PERCENT  -> (null : System.Object) 
  | A_SHL  -> (null : System.Object) 
  | A_SHR  -> (null : System.Object) 
  | A_NOT  -> (null : System.Object) 
  | YMMreg _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | XMMreg _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | R64reg _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | R32reg _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | R16reg _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | R8reg _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | STR _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | ID _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IDeol _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LABEL _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | FLOAT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | INT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | LIT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | EOF  -> (null : System.Object) 
  | EOL  -> (null : System.Object) 
  | AT  -> (null : System.Object) 
  | DOLLAR  -> (null : System.Object) 
  | LPAREN  -> (null : System.Object) 
  | RPAREN  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | R32ip  -> (null : System.Object) 
  | R64ip  -> (null : System.Object) 
  | R32iz  -> (null : System.Object) 
  | R64iz  -> (null : System.Object) 
let _fsyacc_gotos = [| 0us; 65535us; 0us; 65535us; 0us; 65535us; 1us; 65535us; 2us; 3us; 1us; 65535us; 0us; 1us; 1us; 65535us; 4us; 5us; 2us; 65535us; 2us; 7us; 9us; 10us; 5us; 65535us; 2us; 14us; 4us; 13us; 7us; 15us; 9us; 14us; 10us; 15us; 1us; 65535us; 20us; 22us; 5us; 65535us; 2us; 9us; 16us; 17us; 18us; 19us; 20us; 21us; 22us; 23us; 35us; 65535us; 0us; 152us; 20us; 152us; 25us; 152us; 27us; 152us; 41us; 152us; 43us; 152us; 47us; 48us; 49us; 152us; 52us; 153us; 55us; 152us; 103us; 152us; 155us; 152us; 158us; 152us; 160us; 152us; 162us; 152us; 184us; 152us; 185us; 152us; 186us; 152us; 187us; 152us; 188us; 152us; 189us; 152us; 190us; 152us; 191us; 152us; 192us; 152us; 193us; 152us; 194us; 152us; 195us; 152us; 196us; 152us; 197us; 152us; 198us; 152us; 199us; 152us; 200us; 152us; 201us; 152us; 202us; 152us; 203us; 204us; 4us; 65535us; 0us; 12us; 20us; 24us; 25us; 26us; 27us; 28us; 4us; 65535us; 0us; 39us; 20us; 39us; 25us; 39us; 27us; 39us; 5us; 65535us; 0us; 40us; 20us; 40us; 25us; 40us; 27us; 40us; 49us; 51us; 33us; 65535us; 0us; 54us; 20us; 54us; 25us; 54us; 27us; 54us; 41us; 205us; 43us; 205us; 49us; 126us; 52us; 53us; 55us; 205us; 103us; 205us; 155us; 205us; 158us; 205us; 160us; 205us; 162us; 205us; 184us; 205us; 185us; 205us; 186us; 205us; 187us; 205us; 188us; 205us; 189us; 205us; 190us; 205us; 191us; 205us; 192us; 205us; 193us; 205us; 194us; 205us; 195us; 205us; 196us; 205us; 197us; 205us; 198us; 205us; 199us; 205us; 200us; 205us; 201us; 205us; 202us; 205us; 33us; 65535us; 0us; 182us; 20us; 182us; 25us; 182us; 27us; 182us; 41us; 159us; 43us; 161us; 49us; 182us; 52us; 182us; 55us; 156us; 103us; 156us; 155us; 156us; 158us; 159us; 160us; 161us; 162us; 163us; 184us; 164us; 185us; 165us; 186us; 166us; 187us; 167us; 188us; 168us; 189us; 169us; 190us; 170us; 191us; 171us; 192us; 172us; 193us; 173us; 194us; 174us; 195us; 175us; 196us; 176us; 197us; 177us; 198us; 178us; 199us; 179us; 200us; 180us; 201us; 181us; 202us; 183us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 2us; 3us; 5us; 7us; 9us; 12us; 18us; 20us; 26us; 62us; 67us; 72us; 78us; 112us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 2us; 1us; 2us; 1us; 3us; 2us; 4us; 9us; 1us; 4us; 2us; 5us; 21us; 2us; 5us; 9us; 1us; 5us; 1us; 6us; 1us; 7us; 1us; 8us; 1us; 9us; 2us; 10us; 11us; 2us; 11us; 21us; 2us; 12us; 13us; 2us; 13us; 21us; 3us; 14us; 15us; 16us; 2us; 14us; 21us; 4us; 15us; 16us; 18us; 19us; 2us; 16us; 21us; 1us; 17us; 2us; 18us; 19us; 1us; 18us; 1us; 19us; 1us; 19us; 1us; 20us; 1us; 21us; 1us; 22us; 1us; 23us; 1us; 24us; 1us; 25us; 1us; 26us; 1us; 27us; 1us; 28us; 1us; 29us; 1us; 30us; 1us; 31us; 2us; 32us; 74us; 1us; 32us; 2us; 33us; 75us; 1us; 33us; 1us; 34us; 1us; 35us; 1us; 36us; 1us; 36us; 2us; 37us; 38us; 1us; 37us; 1us; 38us; 2us; 39us; 96us; 2us; 39us; 97us; 18us; 40us; 48us; 49us; 50us; 51us; 52us; 53us; 54us; 55us; 63us; 64us; 65us; 66us; 67us; 68us; 69us; 70us; 97us; 15us; 41us; 42us; 43us; 44us; 45us; 46us; 47us; 56us; 57us; 58us; 59us; 60us; 61us; 62us; 73us; 4us; 41us; 42us; 56us; 57us; 1us; 41us; 1us; 41us; 1us; 41us; 1us; 41us; 1us; 42us; 1us; 42us; 1us; 42us; 1us; 42us; 5us; 43us; 44us; 45us; 46us; 47us; 1us; 43us; 4us; 44us; 45us; 46us; 47us; 2us; 44us; 45us; 1us; 44us; 1us; 45us; 1us; 45us; 1us; 45us; 2us; 46us; 47us; 1us; 46us; 1us; 47us; 1us; 47us; 1us; 47us; 16us; 48us; 49us; 50us; 51us; 52us; 53us; 54us; 55us; 63us; 64us; 65us; 66us; 67us; 68us; 69us; 70us; 4us; 48us; 49us; 63us; 64us; 1us; 48us; 1us; 48us; 1us; 48us; 1us; 48us; 1us; 49us; 1us; 49us; 1us; 49us; 1us; 49us; 1us; 50us; 1us; 50us; 5us; 51us; 52us; 53us; 54us; 55us; 1us; 51us; 4us; 52us; 53us; 54us; 55us; 2us; 52us; 53us; 1us; 52us; 1us; 53us; 1us; 53us; 1us; 53us; 2us; 54us; 55us; 1us; 54us; 1us; 55us; 1us; 55us; 1us; 55us; 8us; 56us; 57us; 58us; 59us; 60us; 61us; 62us; 73us; 2us; 56us; 57us; 1us; 56us; 1us; 56us; 1us; 56us; 1us; 56us; 1us; 57us; 1us; 57us; 1us; 57us; 1us; 57us; 5us; 58us; 59us; 60us; 61us; 62us; 1us; 58us; 4us; 59us; 60us; 61us; 62us; 2us; 59us; 60us; 1us; 59us; 1us; 60us; 1us; 60us; 1us; 60us; 2us; 61us; 62us; 1us; 61us; 1us; 62us; 1us; 62us; 1us; 62us; 9us; 63us; 64us; 65us; 66us; 67us; 68us; 69us; 70us; 97us; 8us; 63us; 64us; 65us; 66us; 67us; 68us; 69us; 70us; 2us; 63us; 64us; 1us; 63us; 1us; 63us; 1us; 63us; 1us; 63us; 1us; 64us; 1us; 64us; 1us; 64us; 1us; 64us; 1us; 65us; 1us; 65us; 5us; 66us; 67us; 68us; 69us; 70us; 1us; 66us; 4us; 67us; 68us; 69us; 70us; 2us; 67us; 68us; 1us; 67us; 1us; 68us; 1us; 68us; 1us; 68us; 2us; 69us; 70us; 1us; 69us; 1us; 70us; 1us; 70us; 1us; 70us; 1us; 71us; 2us; 71us; 96us; 1us; 72us; 1us; 73us; 20us; 73us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 1us; 73us; 1us; 74us; 20us; 74us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 1us; 75us; 20us; 75us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 1us; 76us; 20us; 76us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 94us; 95us; 19us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 20us; 77us; 78us; 79us; 80us; 81us; 82us; 83us; 84us; 85us; 86us; 87us; 88us; 89us; 90us; 91us; 92us; 93us; 94us; 95us; 95us; 1us; 77us; 1us; 78us; 1us; 79us; 1us; 80us; 1us; 81us; 1us; 82us; 1us; 83us; 1us; 84us; 1us; 85us; 1us; 86us; 1us; 87us; 1us; 88us; 1us; 89us; 1us; 90us; 1us; 91us; 1us; 92us; 1us; 93us; 1us; 94us; 1us; 95us; 1us; 96us; 1us; 96us; 1us; 97us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 17us; 19us; 22us; 25us; 27us; 29us; 31us; 33us; 35us; 38us; 41us; 44us; 47us; 51us; 54us; 59us; 62us; 64us; 67us; 69us; 71us; 73us; 75us; 77us; 79us; 81us; 83us; 85us; 87us; 89us; 91us; 93us; 95us; 97us; 100us; 102us; 105us; 107us; 109us; 111us; 113us; 115us; 118us; 120us; 122us; 125us; 128us; 147us; 163us; 168us; 170us; 172us; 174us; 176us; 178us; 180us; 182us; 184us; 190us; 192us; 197us; 200us; 202us; 204us; 206us; 208us; 211us; 213us; 215us; 217us; 219us; 236us; 241us; 243us; 245us; 247us; 249us; 251us; 253us; 255us; 257us; 259us; 261us; 267us; 269us; 274us; 277us; 279us; 281us; 283us; 285us; 288us; 290us; 292us; 294us; 296us; 305us; 308us; 310us; 312us; 314us; 316us; 318us; 320us; 322us; 324us; 330us; 332us; 337us; 340us; 342us; 344us; 346us; 348us; 351us; 353us; 355us; 357us; 359us; 369us; 378us; 381us; 383us; 385us; 387us; 389us; 391us; 393us; 395us; 397us; 399us; 401us; 407us; 409us; 414us; 417us; 419us; 421us; 423us; 425us; 428us; 430us; 432us; 434us; 436us; 438us; 441us; 443us; 445us; 466us; 468us; 470us; 491us; 493us; 514us; 516us; 537us; 558us; 579us; 600us; 621us; 642us; 663us; 684us; 705us; 726us; 747us; 768us; 789us; 810us; 831us; 852us; 873us; 894us; 915us; 935us; 956us; 958us; 960us; 962us; 964us; 966us; 968us; 970us; 972us; 974us; 976us; 978us; 980us; 982us; 984us; 986us; 988us; 990us; 992us; 994us; 996us; 998us; |]
let _fsyacc_action_rows = 206
let _fsyacc_actionTableElements = [|18us; 32768us; 12us; 162us; 13us; 41us; 14us; 43us; 15us; 49us; 21us; 38us; 22us; 37us; 23us; 36us; 24us; 35us; 25us; 34us; 26us; 33us; 27us; 46us; 28us; 31us; 29us; 32us; 31us; 45us; 32us; 154us; 36us; 47us; 37us; 52us; 38us; 55us; 0us; 49152us; 5us; 32768us; 28us; 20us; 29us; 18us; 30us; 16us; 34us; 6us; 35us; 29us; 0us; 49152us; 3us; 32768us; 28us; 20us; 29us; 18us; 30us; 16us; 0us; 49152us; 0us; 16387us; 4us; 32768us; 28us; 20us; 29us; 18us; 30us; 16us; 34us; 8us; 0us; 16388us; 4us; 32768us; 28us; 20us; 29us; 18us; 30us; 16us; 35us; 30us; 4us; 32768us; 28us; 20us; 29us; 18us; 30us; 16us; 34us; 11us; 0us; 16389us; 0us; 16390us; 0us; 16391us; 0us; 16392us; 0us; 16393us; 1us; 16394us; 35us; 29us; 1us; 16395us; 35us; 30us; 1us; 16396us; 35us; 29us; 1us; 16397us; 35us; 30us; 19us; 32768us; 12us; 162us; 13us; 41us; 14us; 43us; 15us; 49us; 21us; 38us; 22us; 37us; 23us; 36us; 24us; 35us; 25us; 34us; 26us; 33us; 27us; 46us; 28us; 31us; 29us; 32us; 31us; 45us; 32us; 154us; 35us; 29us; 36us; 47us; 37us; 52us; 38us; 55us; 1us; 16398us; 35us; 30us; 2us; 16399us; 35us; 29us; 40us; 25us; 1us; 16400us; 35us; 30us; 0us; 16401us; 19us; 32768us; 12us; 162us; 13us; 41us; 14us; 43us; 15us; 49us; 21us; 38us; 22us; 37us; 23us; 36us; 24us; 35us; 25us; 34us; 26us; 33us; 27us; 46us; 28us; 31us; 29us; 32us; 31us; 45us; 32us; 154us; 36us; 47us; 37us; 52us; 38us; 55us; 40us; 27us; 0us; 16402us; 18us; 32768us; 12us; 162us; 13us; 41us; 14us; 43us; 15us; 49us; 21us; 38us; 22us; 37us; 23us; 36us; 24us; 35us; 25us; 34us; 26us; 33us; 27us; 46us; 28us; 31us; 29us; 32us; 31us; 45us; 32us; 154us; 36us; 47us; 37us; 52us; 38us; 55us; 0us; 16403us; 0us; 16404us; 0us; 16405us; 0us; 16406us; 0us; 16407us; 0us; 16408us; 0us; 16409us; 0us; 16410us; 0us; 16411us; 0us; 16412us; 0us; 16413us; 0us; 16414us; 0us; 16415us; 9us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 31us; 42us; 32us; 154us; 37us; 203us; 38us; 155us; 0us; 16416us; 9us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 31us; 44us; 32us; 154us; 37us; 203us; 38us; 155us; 0us; 16417us; 0us; 16418us; 0us; 16419us; 2us; 32768us; 28us; 31us; 29us; 32us; 0us; 16420us; 9us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 23us; 50us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 103us; 0us; 16421us; 0us; 16422us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 19us; 16423us; 0us; 16481us; 1us; 16481us; 2us; 16481us; 3us; 16481us; 4us; 16481us; 5us; 16481us; 6us; 16481us; 7us; 16481us; 8us; 16481us; 9us; 16481us; 10us; 16481us; 11us; 16481us; 13us; 16481us; 14us; 16481us; 15us; 16481us; 16us; 16481us; 17us; 16481us; 18us; 16481us; 19us; 16481us; 20us; 16424us; 0us; 16481us; 1us; 16481us; 2us; 16481us; 3us; 16481us; 4us; 16481us; 5us; 16481us; 6us; 16481us; 7us; 16481us; 8us; 16481us; 9us; 16481us; 10us; 16481us; 11us; 16481us; 13us; 16481us; 14us; 16481us; 15us; 16481us; 16us; 16481us; 17us; 16481us; 18us; 16481us; 19us; 16481us; 38us; 78us; 11us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 23us; 113us; 24us; 65us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 40us; 56us; 4us; 32768us; 23us; 109us; 24us; 61us; 43us; 57us; 44us; 105us; 1us; 32768us; 40us; 58us; 1us; 32768us; 32us; 59us; 1us; 32768us; 39us; 60us; 0us; 16425us; 1us; 32768us; 40us; 62us; 1us; 32768us; 32us; 63us; 1us; 32768us; 39us; 64us; 0us; 16426us; 2us; 32768us; 39us; 66us; 40us; 67us; 0us; 16427us; 2us; 32768us; 24us; 73us; 43us; 68us; 2us; 32768us; 39us; 69us; 40us; 70us; 0us; 16428us; 1us; 32768us; 32us; 71us; 1us; 32768us; 39us; 72us; 0us; 16429us; 2us; 32768us; 39us; 74us; 40us; 75us; 0us; 16430us; 1us; 32768us; 32us; 76us; 1us; 32768us; 39us; 77us; 0us; 16431us; 5us; 32768us; 23us; 139us; 24us; 90us; 40us; 79us; 41us; 88us; 42us; 137us; 4us; 32768us; 23us; 133us; 24us; 84us; 43us; 80us; 44us; 129us; 1us; 32768us; 40us; 81us; 1us; 32768us; 32us; 82us; 1us; 32768us; 39us; 83us; 0us; 16432us; 1us; 32768us; 40us; 85us; 1us; 32768us; 32us; 86us; 1us; 32768us; 39us; 87us; 0us; 16433us; 1us; 32768us; 39us; 89us; 0us; 16434us; 2us; 32768us; 39us; 91us; 40us; 92us; 0us; 16435us; 2us; 32768us; 24us; 98us; 43us; 93us; 2us; 32768us; 39us; 94us; 40us; 95us; 0us; 16436us; 1us; 32768us; 32us; 96us; 1us; 32768us; 39us; 97us; 0us; 16437us; 2us; 32768us; 39us; 99us; 40us; 100us; 0us; 16438us; 1us; 32768us; 32us; 101us; 1us; 32768us; 39us; 102us; 0us; 16439us; 10us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 23us; 113us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 40us; 104us; 2us; 32768us; 23us; 109us; 44us; 105us; 1us; 32768us; 40us; 106us; 1us; 32768us; 32us; 107us; 1us; 32768us; 39us; 108us; 0us; 16440us; 1us; 32768us; 40us; 110us; 1us; 32768us; 32us; 111us; 1us; 32768us; 39us; 112us; 0us; 16441us; 2us; 32768us; 39us; 114us; 40us; 115us; 0us; 16442us; 2us; 32768us; 23us; 121us; 44us; 116us; 2us; 32768us; 39us; 117us; 40us; 118us; 0us; 16443us; 1us; 32768us; 32us; 119us; 1us; 32768us; 39us; 120us; 0us; 16444us; 2us; 32768us; 39us; 122us; 40us; 123us; 0us; 16445us; 1us; 32768us; 32us; 124us; 1us; 32768us; 39us; 125us; 0us; 16446us; 1us; 16481us; 38us; 127us; 3us; 32768us; 23us; 139us; 40us; 128us; 42us; 137us; 2us; 32768us; 23us; 133us; 44us; 129us; 1us; 32768us; 40us; 130us; 1us; 32768us; 32us; 131us; 1us; 32768us; 39us; 132us; 0us; 16447us; 1us; 32768us; 40us; 134us; 1us; 32768us; 32us; 135us; 1us; 32768us; 39us; 136us; 0us; 16448us; 1us; 32768us; 39us; 138us; 0us; 16449us; 2us; 32768us; 39us; 140us; 40us; 141us; 0us; 16450us; 2us; 32768us; 23us; 147us; 44us; 142us; 2us; 32768us; 39us; 143us; 40us; 144us; 0us; 16451us; 1us; 32768us; 32us; 145us; 1us; 32768us; 39us; 146us; 0us; 16452us; 2us; 32768us; 39us; 148us; 40us; 149us; 0us; 16453us; 1us; 32768us; 32us; 150us; 1us; 32768us; 39us; 151us; 0us; 16454us; 0us; 16455us; 0us; 16455us; 0us; 16456us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 20us; 32768us; 0us; 196us; 1us; 195us; 2us; 201us; 3us; 202us; 4us; 199us; 5us; 200us; 6us; 198us; 7us; 197us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 13us; 184us; 14us; 185us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 39us; 157us; 0us; 16457us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 0us; 16458us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 0us; 16459us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 0us; 16460us; 9us; 16461us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 9us; 16462us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 0us; 16463us; 0us; 16464us; 0us; 16465us; 0us; 16466us; 0us; 16467us; 5us; 16468us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 5us; 16469us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 5us; 16470us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 5us; 16471us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 17us; 16472us; 2us; 201us; 3us; 202us; 4us; 199us; 5us; 200us; 6us; 198us; 7us; 197us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 13us; 184us; 14us; 185us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 17us; 16473us; 2us; 201us; 3us; 202us; 4us; 199us; 5us; 200us; 6us; 198us; 7us; 197us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 13us; 184us; 14us; 185us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 9us; 16474us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 9us; 16475us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 9us; 16476us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 9us; 16477us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 9us; 16478us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 19us; 32768us; 0us; 196us; 1us; 195us; 2us; 201us; 3us; 202us; 4us; 199us; 5us; 200us; 6us; 198us; 7us; 197us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 13us; 184us; 14us; 185us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 9us; 16479us; 8us; 191us; 9us; 192us; 10us; 193us; 11us; 194us; 15us; 186us; 16us; 187us; 17us; 188us; 18us; 189us; 19us; 190us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 8us; 32768us; 12us; 162us; 13us; 158us; 14us; 160us; 28us; 31us; 29us; 32us; 32us; 154us; 37us; 203us; 38us; 155us; 2us; 32768us; 28us; 31us; 29us; 32us; 0us; 16480us; 0us; 16481us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 19us; 20us; 26us; 27us; 31us; 32us; 33us; 38us; 39us; 44us; 49us; 50us; 51us; 52us; 53us; 54us; 56us; 58us; 60us; 62us; 82us; 84us; 87us; 89us; 90us; 110us; 111us; 130us; 131us; 132us; 133us; 134us; 135us; 136us; 137us; 138us; 139us; 140us; 141us; 142us; 143us; 153us; 154us; 164us; 165us; 166us; 167us; 170us; 171us; 181us; 182us; 183us; 192us; 212us; 233us; 245us; 250us; 252us; 254us; 256us; 257us; 259us; 261us; 263us; 264us; 267us; 268us; 271us; 274us; 275us; 277us; 279us; 280us; 283us; 284us; 286us; 288us; 289us; 295us; 300us; 302us; 304us; 306us; 307us; 309us; 311us; 313us; 314us; 316us; 317us; 320us; 321us; 324us; 327us; 328us; 330us; 332us; 333us; 336us; 337us; 339us; 341us; 342us; 353us; 356us; 358us; 360us; 362us; 363us; 365us; 367us; 369us; 370us; 373us; 374us; 377us; 380us; 381us; 383us; 385us; 386us; 389us; 390us; 392us; 394us; 395us; 397us; 401us; 404us; 406us; 408us; 410us; 411us; 413us; 415us; 417us; 418us; 420us; 421us; 424us; 425us; 428us; 431us; 432us; 434us; 436us; 437us; 440us; 441us; 443us; 445us; 446us; 447us; 448us; 449us; 458us; 479us; 480us; 489us; 490us; 499us; 500us; 509us; 510us; 520us; 530us; 531us; 532us; 533us; 534us; 535us; 541us; 547us; 553us; 559us; 577us; 595us; 605us; 615us; 625us; 635us; 645us; 665us; 675us; 684us; 693us; 702us; 711us; 720us; 729us; 738us; 747us; 756us; 765us; 774us; 783us; 792us; 801us; 810us; 819us; 828us; 837us; 846us; 849us; 850us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 1us; 1us; 1us; 2us; 3us; 1us; 1us; 1us; 2us; 1us; 2us; 1us; 2us; 2us; 2us; 3us; 1us; 3us; 4us; 1us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 2us; 2us; 1us; 1us; 2us; 2us; 2us; 2us; 1us; 6us; 6us; 3us; 5us; 7us; 5us; 7us; 7us; 7us; 4us; 4us; 6us; 8us; 6us; 8us; 6us; 6us; 3us; 5us; 7us; 5us; 7us; 7us; 7us; 4us; 4us; 6us; 8us; 6us; 8us; 1us; 1us; 3us; 2us; 2us; 2us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 3us; 2us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 3us; 3us; 3us; 4us; 5us; 6us; 6us; 7us; 7us; 7us; 7us; 7us; 7us; 7us; 8us; 8us; 8us; 9us; 9us; 10us; 10us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 11us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 12us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 13us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 14us; 15us; 15us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 49152us; 65535us; 49152us; 16387us; 65535us; 16388us; 65535us; 65535us; 16389us; 16390us; 16391us; 16392us; 16393us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16401us; 65535us; 16402us; 65535us; 16403us; 16404us; 16405us; 16406us; 16407us; 16408us; 16409us; 16410us; 16411us; 16412us; 16413us; 16414us; 16415us; 65535us; 16416us; 65535us; 16417us; 16418us; 16419us; 65535us; 16420us; 65535us; 16421us; 16422us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16425us; 65535us; 65535us; 65535us; 16426us; 65535us; 16427us; 65535us; 65535us; 16428us; 65535us; 65535us; 16429us; 65535us; 16430us; 65535us; 65535us; 16431us; 65535us; 65535us; 65535us; 65535us; 65535us; 16432us; 65535us; 65535us; 65535us; 16433us; 65535us; 16434us; 65535us; 16435us; 65535us; 65535us; 16436us; 65535us; 65535us; 16437us; 65535us; 16438us; 65535us; 65535us; 16439us; 65535us; 65535us; 65535us; 65535us; 65535us; 16440us; 65535us; 65535us; 65535us; 16441us; 65535us; 16442us; 65535us; 65535us; 16443us; 65535us; 65535us; 16444us; 65535us; 16445us; 65535us; 65535us; 16446us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16447us; 65535us; 65535us; 65535us; 16448us; 65535us; 16449us; 65535us; 16450us; 65535us; 65535us; 16451us; 65535us; 65535us; 16452us; 65535us; 16453us; 65535us; 65535us; 16454us; 16455us; 65535us; 16456us; 65535us; 65535us; 16457us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16480us; 16481us; |]
let _fsyacc_reductions ()  =    [| 
# 442 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Item)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startASTitem));
# 451 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : ELine [])) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startASTlines));
# 460 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : ELine)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startASTline));
# 469 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 38 "AttParser.fsy"
                                                  [||]                       
                   )
# 38 "AttParser.fsy"
                 : ELine []));
# 479 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Lines1)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 39 "AttParser.fsy"
                                                  Array.ofList(List.rev(_1)) 
                   )
# 39 "AttParser.fsy"
                 : ELine []));
# 490 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'EOLS)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Lines1)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 40 "AttParser.fsy"
                                                  Array.ofList(List.rev(_2)) 
                   )
# 40 "AttParser.fsy"
                 : ELine []));
# 502 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Item)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 42 "AttParser.fsy"
                                      _1 
                   )
# 42 "AttParser.fsy"
                 : Item));
# 513 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Line)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 44 "AttParser.fsy"
                                      _1 
                   )
# 44 "AttParser.fsy"
                 : ELine));
# 524 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Line)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 48 "AttParser.fsy"
                                            [_1]   
                   )
# 48 "AttParser.fsy"
                 : 'Lines1));
# 535 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Lines1)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Line)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 49 "AttParser.fsy"
                                            _2::_1 
                   )
# 49 "AttParser.fsy"
                 : 'Lines1));
# 547 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 51 "AttParser.fsy"
                                             ELine.Label(_1)              
                   )
# 51 "AttParser.fsy"
                 : 'Line));
# 558 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'EOLS)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 52 "AttParser.fsy"
                                             ELine.Label(_1)              
                   )
# 52 "AttParser.fsy"
                 : 'Line));
# 570 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 53 "AttParser.fsy"
                                             ELine.Tagged(_1,[])          
                   )
# 53 "AttParser.fsy"
                 : 'Line));
# 581 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'EOLS)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 54 "AttParser.fsy"
                                             ELine.Tagged(_1,[])          
                   )
# 54 "AttParser.fsy"
                 : 'Line));
# 593 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'EOLS)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 55 "AttParser.fsy"
                                             ELine.Tagged(_1,[])          
                   )
# 55 "AttParser.fsy"
                 : 'Line));
# 605 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Items1)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 56 "AttParser.fsy"
                                             ELine.Tagged(_1,List.rev _2) 
                   )
# 56 "AttParser.fsy"
                 : 'Line));
# 617 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Items1)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'EOLS)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 57 "AttParser.fsy"
                                             ELine.Tagged(_1,List.rev _2) 
                   )
# 57 "AttParser.fsy"
                 : 'Line));
# 630 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Item)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 59 "AttParser.fsy"
                                                        [_1]         
                   )
# 59 "AttParser.fsy"
                 : 'Items1));
# 641 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Items1)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'Item)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 60 "AttParser.fsy"
                                                        _3::_1       
                   )
# 60 "AttParser.fsy"
                 : 'Items1));
# 653 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Items1)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'Item)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 61 "AttParser.fsy"
                                                        _4::Unit::_1 
                   )
# 61 "AttParser.fsy"
                 : 'Items1));
# 665 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 63 "AttParser.fsy"
                                       () 
                   )
# 63 "AttParser.fsy"
                 : 'EOLS));
# 675 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'EOLS)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 64 "AttParser.fsy"
                                       () 
                   )
# 64 "AttParser.fsy"
                 : 'EOLS));
# 686 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 66 "AttParser.fsy"
                                   _1 
                   )
# 66 "AttParser.fsy"
                 : 'IDx));
# 697 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 67 "AttParser.fsy"
                                   _1 
                   )
# 67 "AttParser.fsy"
                 : 'IDx));
# 708 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R8)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 69 "AttParser.fsy"
                                           Item.R8reg(_1)                    
                   )
# 69 "AttParser.fsy"
                 : 'Item));
# 719 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R16)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 70 "AttParser.fsy"
                                           Item.R16reg(_1)                   
                   )
# 70 "AttParser.fsy"
                 : 'Item));
# 730 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 71 "AttParser.fsy"
                                           Item.R32reg(_1)                   
                   )
# 71 "AttParser.fsy"
                 : 'Item));
# 741 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 72 "AttParser.fsy"
                                           Item.R64reg(_1)                   
                   )
# 72 "AttParser.fsy"
                 : 'Item));
# 752 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.X)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 73 "AttParser.fsy"
                                           Item.XMMreg(_1)                   
                   )
# 73 "AttParser.fsy"
                 : 'Item));
# 763 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.Y)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 74 "AttParser.fsy"
                                           Item.YMMreg(_1)                   
                   )
# 74 "AttParser.fsy"
                 : 'Item));
# 774 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'EA32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 76 "AttParser.fsy"
                                           Item.Mem(_1)                      
                   )
# 76 "AttParser.fsy"
                 : 'Item));
# 785 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'EA64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 77 "AttParser.fsy"
                                           Item.Mem(_1)                      
                   )
# 77 "AttParser.fsy"
                 : 'Item));
# 796 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : System.Double)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 78 "AttParser.fsy"
                                           Item.Float(_2)                    
                   )
# 78 "AttParser.fsy"
                 : 'Item));
# 807 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : System.Double)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 79 "AttParser.fsy"
                                           Item.Float(-_2)                   
                   )
# 79 "AttParser.fsy"
                 : 'Item));
# 818 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.Double)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 80 "AttParser.fsy"
                                           Item.Float(_1)                    
                   )
# 80 "AttParser.fsy"
                 : 'Item));
# 829 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.String)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 81 "AttParser.fsy"
                                           Item.String(_1)                   
                   )
# 81 "AttParser.fsy"
                 : 'Item));
# 840 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'IDx)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 82 "AttParser.fsy"
                                           Item.Type(_2)                     
                   )
# 82 "AttParser.fsy"
                 : 'Item));
# 851 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 83 "AttParser.fsy"
                                           Item.NR64reg({NR64.S = _2})       
                   )
# 83 "AttParser.fsy"
                 : 'Item));
# 862 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'EA64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 84 "AttParser.fsy"
                                           Item.NMem({NM64.S = M64.S(_2)})   
                   )
# 84 "AttParser.fsy"
                 : 'Item));
# 873 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 85 "AttParser.fsy"
                                           Item.Literal((_2:Iexpr).Simplify) 
                   )
# 85 "AttParser.fsy"
                 : 'Item));
# 884 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 86 "AttParser.fsy"
                                           Item.Iexpr(_1.Simplify)           
                   )
# 86 "AttParser.fsy"
                 : 'Item));
# 895 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 88 "AttParser.fsy"
                                                                                EA32(Iexpr.Zero,  None,               None                                  ) 
                   )
# 88 "AttParser.fsy"
                 : 'EA32));
# 906 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 89 "AttParser.fsy"
                                                                                EA32(Iexpr.Zero,  None,               Some { Index = _3; Scale = int64(_5) }) 
                   )
# 89 "AttParser.fsy"
                 : 'EA32));
# 918 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 90 "AttParser.fsy"
                                                                                EA32(Iexpr.Zero,  Some { Base = _2 }, None                                  ) 
                   )
# 90 "AttParser.fsy"
                 : 'EA32));
# 929 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 91 "AttParser.fsy"
                                                                                EA32(Iexpr.Zero,  Some { Base = _2 }, None                                  ) 
                   )
# 91 "AttParser.fsy"
                 : 'EA32));
# 940 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 92 "AttParser.fsy"
                                                                                EA32(Iexpr.Zero,  Some { Base = _2 }, None                                  ) 
                   )
# 92 "AttParser.fsy"
                 : 'EA32));
# 952 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 93 "AttParser.fsy"
                                                                                EA32(Iexpr.Zero,  Some { Base = _2 }, Some { Index = _4; Scale = 1L        }) 
                   )
# 93 "AttParser.fsy"
                 : 'EA32));
# 964 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 94 "AttParser.fsy"
                                                                                EA32(Iexpr.Zero,  Some { Base = _2 }, Some { Index = _4; Scale = int64(_6) }) 
                   )
# 94 "AttParser.fsy"
                 : 'EA32));
# 977 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 95 "AttParser.fsy"
                                                                                EA32(_1.Simplify, None,               None                                  ) 
                   )
# 95 "AttParser.fsy"
                 : 'EA32));
# 989 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 96 "AttParser.fsy"
                                                                                EA32(_1.Simplify, None,               Some { Index = _4; Scale = int64(_6) }) 
                   )
# 96 "AttParser.fsy"
                 : 'EA32));
# 1002 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 97 "AttParser.fsy"
                                                                                K32eip(_1)                                                                    
                   )
# 97 "AttParser.fsy"
                 : 'EA32));
# 1013 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 98 "AttParser.fsy"
                                                                                EA32(_1.Simplify, Some { Base = _3 }, None                                  ) 
                   )
# 98 "AttParser.fsy"
                 : 'EA32));
# 1025 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 99 "AttParser.fsy"
                                                                                EA32(_1.Simplify, Some { Base = _3 }, None                                  ) 
                   )
# 99 "AttParser.fsy"
                 : 'EA32));
# 1037 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 100 "AttParser.fsy"
                                                                                EA32(_1.Simplify, Some { Base = _3 }, None                                  ) 
                   )
# 100 "AttParser.fsy"
                 : 'EA32));
# 1050 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 101 "AttParser.fsy"
                                                                                EA32(_1.Simplify, Some { Base = _3 }, Some { Index = _5; Scale = 1L        }) 
                   )
# 101 "AttParser.fsy"
                 : 'EA32));
# 1063 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R32)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 102 "AttParser.fsy"
                                                                                EA32(_1.Simplify, Some { Base = _3 }, Some { Index = _5; Scale = int64(_7) }) 
                   )
# 102 "AttParser.fsy"
                 : 'EA32));
# 1077 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 104 "AttParser.fsy"
                                                                                EA64(Iexpr.Zero,  None,               None                                  ) 
                   )
# 104 "AttParser.fsy"
                 : 'EA64));
# 1088 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 105 "AttParser.fsy"
                                                                                EA64(Iexpr.Zero,  None,               Some { Index = _3; Scale = int64(_5) }) 
                   )
# 105 "AttParser.fsy"
                 : 'EA64));
# 1100 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 106 "AttParser.fsy"
                                                                                EA64(Iexpr.Zero,  Some { Base = _2 }, None                                  ) 
                   )
# 106 "AttParser.fsy"
                 : 'EA64));
# 1111 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 107 "AttParser.fsy"
                                                                                EA64(Iexpr.Zero,  Some { Base = _2 }, None                                  ) 
                   )
# 107 "AttParser.fsy"
                 : 'EA64));
# 1122 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 108 "AttParser.fsy"
                                                                                EA64(Iexpr.Zero,  Some { Base = _2 }, None                                  ) 
                   )
# 108 "AttParser.fsy"
                 : 'EA64));
# 1134 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 109 "AttParser.fsy"
                                                                                EA64(Iexpr.Zero,  Some { Base = _2 }, Some { Index = _4; Scale = 1L        }) 
                   )
# 109 "AttParser.fsy"
                 : 'EA64));
# 1146 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 110 "AttParser.fsy"
                                                                                EA64(Iexpr.Zero,  Some { Base = _2 }, Some { Index = _4; Scale = int64(_6) }) 
                   )
# 110 "AttParser.fsy"
                 : 'EA64));
# 1159 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 111 "AttParser.fsy"
                                                                                EA64(_1.Simplify, None,               None                                  ) 
                   )
# 111 "AttParser.fsy"
                 : 'EA64));
# 1171 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 112 "AttParser.fsy"
                                                                                EA64(_1.Simplify, None,               Some { Index = _4; Scale = int64(_6) }) 
                   )
# 112 "AttParser.fsy"
                 : 'EA64));
# 1184 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 113 "AttParser.fsy"
                                                                                K64rip(_1)                                                                    
                   )
# 113 "AttParser.fsy"
                 : 'EA64));
# 1195 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 114 "AttParser.fsy"
                                                                                EA64(_1.Simplify, Some { Base = _3 }, None                                  ) 
                   )
# 114 "AttParser.fsy"
                 : 'EA64));
# 1207 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 115 "AttParser.fsy"
                                                                                EA64(_1.Simplify, Some { Base = _3 }, None                                  ) 
                   )
# 115 "AttParser.fsy"
                 : 'EA64));
# 1219 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 116 "AttParser.fsy"
                                                                                EA64(_1.Simplify, Some { Base = _3 }, None                                  ) 
                   )
# 116 "AttParser.fsy"
                 : 'EA64));
# 1232 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 117 "AttParser.fsy"
                                                                                EA64(_1.Simplify, Some { Base = _3 }, Some { Index = _5; Scale = 1L        }) 
                   )
# 117 "AttParser.fsy"
                 : 'EA64));
# 1245 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : X64instr.R64)) in
            let _7 = (let data = parseState.GetInput(7) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 118 "AttParser.fsy"
                                                                                EA64(_1.Simplify, Some { Base = _3 }, Some { Index = _5; Scale = int64(_7) }) 
                   )
# 118 "AttParser.fsy"
                 : 'EA64));
# 1259 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IDx)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 120 "AttParser.fsy"
                                                         Iexpr.Id({ Name = _1 })                 
                   )
# 120 "AttParser.fsy"
                 : 'Iexpr));
# 1270 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : System.Numerics.BigInteger)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 121 "AttParser.fsy"
                                                         Iexpr.Int(_1)                           
                   )
# 121 "AttParser.fsy"
                 : 'Iexpr));
# 1281 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 122 "AttParser.fsy"
                                                         _2                                      
                   )
# 122 "AttParser.fsy"
                 : 'Iexpr));
# 1292 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 123 "AttParser.fsy"
                                                         _2                                      
                   )
# 123 "AttParser.fsy"
                 : 'Iexpr));
# 1303 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 124 "AttParser.fsy"
                                                         Iexpr.Unary(IunaryOp.A_NEG, _2)         
                   )
# 124 "AttParser.fsy"
                 : 'Iexpr));
# 1314 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 125 "AttParser.fsy"
                                                         Iexpr.Unary(IunaryOp.B_NEG, _2)         
                   )
# 125 "AttParser.fsy"
                 : 'Iexpr));
# 1325 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 126 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.A_ADD, _1, _3)   
                   )
# 126 "AttParser.fsy"
                 : 'Iexpr));
# 1337 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 127 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.A_SUB, _1, _3)   
                   )
# 127 "AttParser.fsy"
                 : 'Iexpr));
# 1349 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 128 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.A_MUL, _1, _3)   
                   )
# 128 "AttParser.fsy"
                 : 'Iexpr));
# 1361 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 129 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.A_DIV, _1, _3)   
                   )
# 129 "AttParser.fsy"
                 : 'Iexpr));
# 1373 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 130 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.A_REM, _1, _3)   
                   )
# 130 "AttParser.fsy"
                 : 'Iexpr));
# 1385 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 131 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.A_SHL, _1, _3)   
                   )
# 131 "AttParser.fsy"
                 : 'Iexpr));
# 1397 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 132 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.A_SHR, _1, _3)   
                   )
# 132 "AttParser.fsy"
                 : 'Iexpr));
# 1409 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 133 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.B_IOR, _1, _3)   
                   )
# 133 "AttParser.fsy"
                 : 'Iexpr));
# 1421 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 134 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.B_AND, _1, _3)   
                   )
# 134 "AttParser.fsy"
                 : 'Iexpr));
# 1433 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 135 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.B_XOR, _1, _3)   
                   )
# 135 "AttParser.fsy"
                 : 'Iexpr));
# 1445 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 136 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.B_ORNOT, _1, _3) 
                   )
# 136 "AttParser.fsy"
                 : 'Iexpr));
# 1457 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 137 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_AND, _1, _3)   
                   )
# 137 "AttParser.fsy"
                 : 'Iexpr));
# 1469 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 138 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_OR, _1, _3)    
                   )
# 138 "AttParser.fsy"
                 : 'Iexpr));
# 1481 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 139 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_EQ, _1, _3)    
                   )
# 139 "AttParser.fsy"
                 : 'Iexpr));
# 1493 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 140 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_NEQ, _1, _3)   
                   )
# 140 "AttParser.fsy"
                 : 'Iexpr));
# 1505 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 141 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_LT, _1, _3)    
                   )
# 141 "AttParser.fsy"
                 : 'Iexpr));
# 1517 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 142 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_GT, _1, _3)    
                   )
# 142 "AttParser.fsy"
                 : 'Iexpr));
# 1529 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 143 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_LEQ, _1, _3)   
                   )
# 143 "AttParser.fsy"
                 : 'Iexpr));
# 1541 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'IexprI)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 144 "AttParser.fsy"
                                                         Iexpr.Binary(IbinaryOp.L_GEQ, _1, _3)   
                   )
# 144 "AttParser.fsy"
                 : 'Iexpr));
# 1553 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'IDx)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 146 "AttParser.fsy"
                                           Iexpr.Id { Name = "$" + _2 } 
                   )
# 146 "AttParser.fsy"
                 : 'IexprI));
# 1564 "AttParser.fs"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'Iexpr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 147 "AttParser.fsy"
                                           _1                           
                   )
# 147 "AttParser.fsy"
                 : 'IexprI));
|]
# 1576 "AttParser.fs"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 48;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let ASTitem lexer lexbuf : Item =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
let ASTlines lexer lexbuf : ELine [] =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 2))
let ASTline lexer lexbuf : ELine =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 4))
