// Signature file for parser generated by fsyacc
module AttParser
type token = 
  | L_OR
  | L_AND
  | L_LEQ
  | L_GEQ
  | L_LT
  | L_GT
  | L_NEQ
  | L_EQ
  | PIPE
  | AMPERSAND
  | HAT
  | BANG
  | TILDE
  | PLUS
  | MINUS
  | STAR
  | SLASH
  | PERCENT
  | A_SHL
  | A_SHR
  | A_NOT
  | YMMreg of (X64instr.Y)
  | XMMreg of (X64instr.X)
  | R64reg of (X64instr.R64)
  | R32reg of (X64instr.R32)
  | R16reg of (X64instr.R16)
  | R8reg of (X64instr.R8)
  | STR of (System.String)
  | ID of (System.String)
  | IDeol of (System.String)
  | LABEL of (System.String)
  | FLOAT of (System.Double)
  | INT of (System.Numerics.BigInteger)
  | LIT of (System.Numerics.BigInteger)
  | EOF
  | EOL
  | AT
  | DOLLAR
  | LPAREN
  | RPAREN
  | COMMA
  | R32ip
  | R64ip
  | R32iz
  | R64iz
type tokenId = 
    | TOKEN_L_OR
    | TOKEN_L_AND
    | TOKEN_L_LEQ
    | TOKEN_L_GEQ
    | TOKEN_L_LT
    | TOKEN_L_GT
    | TOKEN_L_NEQ
    | TOKEN_L_EQ
    | TOKEN_PIPE
    | TOKEN_AMPERSAND
    | TOKEN_HAT
    | TOKEN_BANG
    | TOKEN_TILDE
    | TOKEN_PLUS
    | TOKEN_MINUS
    | TOKEN_STAR
    | TOKEN_SLASH
    | TOKEN_PERCENT
    | TOKEN_A_SHL
    | TOKEN_A_SHR
    | TOKEN_A_NOT
    | TOKEN_YMMreg
    | TOKEN_XMMreg
    | TOKEN_R64reg
    | TOKEN_R32reg
    | TOKEN_R16reg
    | TOKEN_R8reg
    | TOKEN_STR
    | TOKEN_ID
    | TOKEN_IDeol
    | TOKEN_LABEL
    | TOKEN_FLOAT
    | TOKEN_INT
    | TOKEN_LIT
    | TOKEN_EOF
    | TOKEN_EOL
    | TOKEN_AT
    | TOKEN_DOLLAR
    | TOKEN_LPAREN
    | TOKEN_RPAREN
    | TOKEN_COMMA
    | TOKEN_R32ip
    | TOKEN_R64ip
    | TOKEN_R32iz
    | TOKEN_R64iz
    | TOKEN_end_of_input
    | TOKEN_error
type nonTerminalId = 
    | NONTERM__startASTitem
    | NONTERM__startASTlines
    | NONTERM__startASTline
    | NONTERM_ASTlines
    | NONTERM_ASTitem
    | NONTERM_ASTline
    | NONTERM_Lines1
    | NONTERM_Line
    | NONTERM_Items1
    | NONTERM_EOLS
    | NONTERM_IDx
    | NONTERM_Item
    | NONTERM_EA32
    | NONTERM_EA64
    | NONTERM_Iexpr
    | NONTERM_IexprI
/// This function maps integers indexes to symbolic token ids
val tagOfToken: token -> int

/// This function maps integers indexes to symbolic token ids
val tokenTagToTokenId: int -> tokenId

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
val prodIdxToNonTerminal: int -> nonTerminalId

/// This function gets the name of a token as a string
val token_to_string: token -> string
val ASTitem : (Microsoft.FSharp.Text.Lexing.LexBuffer<'cty> -> token) -> Microsoft.FSharp.Text.Lexing.LexBuffer<'cty> -> (Item) 
val ASTlines : (Microsoft.FSharp.Text.Lexing.LexBuffer<'cty> -> token) -> Microsoft.FSharp.Text.Lexing.LexBuffer<'cty> -> (ELine []) 
val ASTline : (Microsoft.FSharp.Text.Lexing.LexBuffer<'cty> -> token) -> Microsoft.FSharp.Text.Lexing.LexBuffer<'cty> -> (ELine) 
