module OptForwardStoreToLoad


open System
open System.Collections.Generic

open Ast
open X64instr

open InstrIO
open MoreInstrIO

open AstIO
open MoreAstIO


open NXyn
open NXyn.Aux
open NXyn.Aux.Global

open NXyn.Aux.IntMisc
open NXyn.Aux.OtherMisc
open NXyn.Aux.SetMisc


open Basics

open LocalScheduling


//            index
open OptSimple


let do_opt (b:IBlock) (in0:Set<Operand>) (out0:Set<Operand>) (instrs:Instr []) =

            let instrs = Array.toList(instrs)

            let instrs = instrs |> moveDown_Instrs_like b (fun(i) -> (Fs_of_Instr(i) <> [] || Fd_of_Instr(i) <> []) &&
                                                                     (match i with R64sR64d(_) | R64sR64ds(_) | M64sR64ds(_) | R64sR64s(_) | R64ds(_) | M64sR64s(_) | R64sM64s(_) -> true | _ -> false) &&
                                                                     List.forall ((<>)R.rsp) (Rds_of_Instr(i)) && // NEW
                                                                     List.forall ((<>)R.rsp) (Rd_of_Instr(i)))
                                |> moveDown_Instrs_like b (fun(i) -> let ms = Ms_of_Instr(i)
                                                                     if Mds_of_Instr(i) = [] && Md_of_Instr(i) = [] then
                                                                         match ms with
                                                                             | [(_,EA64(_,Some{Base=r},None))] when r = R64.rsp ->
                                                                                   match i with M128sXd((I_M128sXd.Movapd | I_M128sXd.Movaps),_) -> true
                                                                                              | M128sXds(_) -> true
                                                                                              | _ -> false
                                                                             | _ -> false
                                                                     else false)
                                
                                |> moveDown_Instrs_like b (fun(i) -> match i with XsXd(_) -> true | _ -> false)
                                |> moveDown_Instrs_like b (fun(i) -> match i with M128sXd(_) -> true | _ -> false)


                                |> moveUp_Instrs_like b (fun (instr,aux,_,_,_) instrs ->
                                                           match instr with XsXds(_,{S=s;DS=_}) -> nextReader_of' (Operand_of_X s) instrs = None
                                                                          | M128sXds(_) -> true
                                                                          | _ -> false
                                                        )

                                |> moveUp_Instrs_like b (fun (instr,aux,_,_,_) instrs ->
                                                           match instr with XsM128d(_) -> true
                                                           //,{S=_; D=M128.S(EA64(_,Some{Base=r},None))}) when r = R64.rsp ->
//                                                                                 eprintfn "moveup %A" instr
//                                                                                 true
                                                                          | _ -> false
                                                        )


//            let (in0,out0) = inoutDict.[lbl]





            let nremovedU = ref 0
            let nremovedU2 = ref 0
            let nremovedU3 = ref 0
            let rec loopU bag = function
                | [] -> List.rev(bag)
                | [i] -> List.rev(i::bag)
                | (XsM128d((I_XsM128d.Movapd | I_XsM128d.Movaps), {S=s1;D=M128.S(d1)}) as instr) :: instrs ->
                    match stackLocOption(16,d1) with
                        | Some(size1,ofs1) when not (Set.contains (PstackB ofs1) out0) ->

//let nonoverlapping_stackLoc (size1,ofs1) (size2,ofs2) = ofs2 >= ofs1 + size1 || ofs1 >= ofs2 + size2

                            
                            match nextReader_of b (PstackB(ofs1)) instrs with
                                // DAS sind 2 FAELLE!!!!
                                // S1 wird geschrieben, aber D1 nicht
                                // S1 wird nicht geschrieben

                                | Some(pre',M128sXd((I_M128sXd.Movaps | I_M128sXd.Movapd), {S=M128.S(s2);D=d2}), post)
                                  when s2 = d1
                                    && not (Set.contains (Operand_of_X d2) out0)
                                    && not (Set.contains (Operand_of_X s1) out0)

                                    && nextReader_of b (Operand_of_X s1) instrs = None
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X s1) (S_of_Instr  konstSizeDict b.ReturnsVoid i))) pre'
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X s1) (DS_of_Instr i))) pre'
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X s1) (D_of_Instr  i))) pre'

                                    && List.forall (fun(i) ->
                                                       let m = (Md_of_Instr(i) @ Mds_of_Instr(i)) |> List.choose stackLocOption
                                                       List.forall (fun(size2,ofs2) -> nonoverlapping_stackLoc (size1,ofs1) (size2,ofs2)) m
                                                   ) pre'
                                       -> //eprintfn "U %A" instr
                                          incr nremovedU3


                                          let instrs = (List.rev pre') @ (List.map (fun(i) -> (Map_X_in_Instr (swap2 d2 s1) i)) post)
                                          loopU (instr :: bag) instrs

                                
                                | Some(pre',M128sXd((I_M128sXd.Movaps | I_M128sXd.Movapd), {S=M128.S(s2);D=d2}), post)
                                  when s2 = d1
                                    && not (Set.contains (Operand_of_X d2) out0)
                                    && not (Set.contains (Operand_of_X s1) out0)
                                    && nextReader_of b (Operand_of_X s1) instrs = None
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X d2) (S_of_Instr  konstSizeDict b.ReturnsVoid i))) pre'
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X d2) (DS_of_Instr i))) pre'
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X d2) (D_of_Instr  i))) pre'

                                    && List.forall (fun(i) ->
                                                       let m = (Md_of_Instr(i) @ Mds_of_Instr(i)) |> List.choose stackLocOption
                                                       List.forall (fun(size2,ofs2) -> nonoverlapping_stackLoc (size1,ofs1) (size2,ofs2)) m
                                                   ) pre'
                                       -> //eprintfn "U %A" instr
                                          incr nremovedU2


                                          let instrs = (List.map (fun(i) -> (Map_X_in_Instr (swap2 d2 s1) i)) ((List.rev pre') @ post))
                                          loopU (instr :: bag) instrs
                                        
                                | Some(pre',M128sXds(op2, {S=M128.S(s2);DS=ds2}), post)
                                  when s2 = d1
                                    && List.forall (fun(i) ->
                                                       let m = (Md_of_Instr(i) @ Mds_of_Instr(i)) |> List.choose stackLocOption
                                                       List.forall (fun(size2,ofs2) -> nonoverlapping_stackLoc (size1,ofs1) (size2,ofs2)) m
                                                   ) pre'
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X s1) (DS_of_Instr i))) pre'
                                    && List.forall (fun(i) -> not(Set.contains (Operand_of_X s1) (D_of_Instr  i))) pre'
                                       -> match try__XsXds_of_M128sXds(op2) with
                                              | None -> loopU (instr::bag) instrs
                                              | Some(op2') ->
                                                  incr nremovedU
                                          
                                                  let instrs = ([instr] @ (List.rev pre') @ [XsXds(op2',{S=s1;DS=ds2})] @ post)
                                                  loopU bag instrs
                                | _ -> loopU (instr :: bag) instrs
                        | _ -> loopU (instr :: bag) instrs
                | instr :: instrs -> loopU (instr :: bag) instrs
            let instrs = loopU [] instrs


            let nremovedV = ref 0
            let rec loopV bag = function
                | [] -> List.rev(bag)
                | [i] -> List.rev(i::bag)
                | i1::i2::instrs ->
                    match (i1,i2) with
                        | M128sXd((I_M128sXd.Movapd | I_M128sXd.Movaps), {S=s1;D=d1}), XsM128d((I_XsM128d.Movapd | I_XsM128d.Movaps), {S=s2;D=d2})
                          when d1=s2 && s1=d2 ->
                              incr nremovedV
                              loopV (i1::bag) instrs
                        | _ -> loopV (i1::bag) (i2::instrs)
            let instrs = loopV [] instrs



//            eprintfn "%s: nremovedU = %d, nremovedU2 = %d, nremovedU3 = %d, nremovedV = %d" !Global.InFileName !nremovedU !nremovedU2 !nremovedU3 !nremovedV





            // this in GlobalScheduling


            Array.ofList(instrs)
