#!/bin/bash

EXPECTED_ARGS=1

# check for expected number of command line arguments
E_BADARGS=65
if [ $# -ne $EXPECTED_ARGS ]
then
    
  TARGET_DIR=~
  echo "no target directory specified"
  echo "using home directory as target"
#  echo "Usage: `basename $0` {arg}"
#  exit $E_BADARGS
else
  TARGET_DIR=$1
fi

echo "target = $TARGET_DIR"

# remove all trailing slashes from path name 
pattern='^(.*[^/])/*$'
[[ $TARGET_DIR =~ $pattern ]]
TARGET_DIR=${BASH_REMATCH[1]}/nxyn

echo "target = $TARGET_DIR"

# possibly cleanup before install
rm -fr $TARGET_DIR

mkdir $TARGET_DIR

echo "copying script files"
cp scripts/* $TARGET_DIR

echo "copying binary executables"
cp NXcc/nxcc.exe          $TARGET_DIR
cp NXas/nxas_parse.exe    $TARGET_DIR
cp NXas/nxas_opt.exe      $TARGET_DIR
cp NXas/nxas_unparse.exe  $TARGET_DIR

echo "copying libraries"
cp Aux/Aux.dll            $TARGET_DIR
cp JSON/JSON.dll          $TARGET_DIR
cp */*.netmodule          $TARGET_DIR

echo "copying F# Powerpack libraries"
cp FSharpPowerPack-2.0.0.0/bin/FSharp.PowerPack.dll  $TARGET_DIR


# copy old .bashrc
cp ~/.bashrc ~/.bashrc.old

# cleanup `.bashrc'
BASHRC_LINE1="export NXYN_DIR=$TARGET_DIR"
BASHRC_LINE2="export PATH=\$PATH:\$NXYN_DIR"

cat ~/.bashrc | grep -v "$BASHRC_LINE1" | grep -v "$BASHRC_LINE2" > .bashrc.new

# add `.bashrc'
echo $BASHRC_LINE1 >> .bashrc.new
echo $BASHRC_LINE2 >> .bashrc.new

# copy back .bashrc
cp .bashrc.new ~/.bashrc

# remove temporary file
rm -f .bashrc.new


